import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.*;
import javax.ejb.*;
import test.*;


public class CAAccount extends HttpServlet {
  private AccountLocalHome accountHome = null;
  private VerificationLocalHome verificationHome = null;
  private CertificationLocalHome certificationHome = null;

  public void init()
    throws ServletException
  {
    try {
      Context cmp = (Context) new InitialContext().lookup("java:comp/env/cmp");

      accountHome = (AccountLocalHome) cmp.lookup("AccountBean");
      verificationHome = (VerificationLocalHome)cmp.lookup("VerificationBean");
      certificationHome = (CertificationLocalHome)cmp.lookup("CertificationBean");
    } catch (NamingException e) {
      e.printStackTrace();
    }
  }

  public void doGet(HttpServletRequest req, HttpServletResponse res)
    throws IOException, ServletException {

    PrintWriter out = res.getWriter();
    res.setContentType("text/html");

    out.println("<h3>Account Details</h3>");
      
    try {

      if (verificationHome == null) {
        out.println("home is null");
      } else {
        VerificationLocal verification = verificationHome.create();
        out.println("Do Verification? : " + verification.doVerification("jdoe", "password", "certificate") + "<BR>");
      }

      if (certificationHome == null) {
        out.println("home is null");
      } else {
        CertificationLocal certification = certificationHome.create();
        out.println("Get Certificate : " + certification.getCertificate("jdoe", "password") + "<BR>");
      }
    }
    catch ( CreateException e) {
      e.printStackTrace();
    }

  }

  public void doPost(HttpServletRequest req, HttpServletResponse res)
    throws IOException, ServletException { 
    doGet(req, res);
  }

}
