package _ejb.test;

import com.caucho.ejb.*;
import com.caucho.vfs.*;
import javax.ejb.*;

public class VerificationBean__EJB extends QSessionContext {
  private static WriteStream dbg = LogStream.open("/caucho.com/ejb/bean");

  Bean _ejb_top_bean;
  ServerContainer container;
  SessionServer server;

  protected void init(SessionServer server)
  {
    this.server = server;
    this.container = server.getContainer();
  }

  public AbstractServer getServer()
  {
    return server;
  }

  public SessionServer getSessionServer()
  {
    return server;
  }

  Bean _caucho_begin(TransactionContext trans, boolean isHome)
    throws javax.ejb.EJBException
  {
    Bean ptr;
    synchronized (this) {
      for (ptr = _ejb_top_bean; ptr != null; ptr = ptr._ejb_next) {
        if (! ptr._ejb_isActive) {
          ptr._ejb_isActive = true;
          return ptr;
        }
      }

      ptr = new Bean(this);
      ptr._ejb_next = _ejb_top_bean;
      _ejb_top_bean = ptr;
      ptr._ejb_isActive = true;
    }

    return ptr;
  }

  public void destroy()
  {
    Bean ptr;
    synchronized (this) {
      for (ptr = _ejb_top_bean; ptr != null; ptr = ptr._ejb_next) {
        try {
          ptr.ejbRemove();
        } catch (Exception e) {
          dbg.log(e);
        }
      }
    }
    _ejb_top_bean = null;
  }

  public static class Bean extends test.VerificationBean
  {
    Bean _ejb_next;
    VerificationBean__EJB _ejb_context;
    boolean _ejb_isActive;

    Bean(VerificationBean__EJB context)
    {
      try {
        _ejb_context = context;
        setSessionContext(context);
        ejbCreate();
      } catch (Exception e) {
        dbg.log(e);
        throw com.caucho.ejb.EJBExceptionWrapper.create(e);
      }
    }
  }

  public EJBHome createRemoteHomeView()
  {
    return new Home(this);
  }

  public class Home extends SessionHome implements test.VerificationHome {
    private VerificationBean__EJB context;
    private SessionServer server;
    private ServerContainer container;

    Home(VerificationBean__EJB context)
    {
      this.context = context;
      this.server = context.getSessionServer();
      this.container = server.getContainer();
    }

    private VerificationBean__EJB getContext()
    {
      return context;
    }

    public SessionServer getServer()
    {
      return server;
    }

    public test.Verification create()
      throws java.rmi.RemoteException, javax.ejb.CreateException
    {
      _ejb.test.VerificationBean__EJB cxt = getContext();

      return (test.Verification) cxt.getEJBObject();
    }
  }

  private Remote viewRemote;

  public EJBObject getRemoteView()
  {
    if (viewRemote == null)
      viewRemote = new Remote(this);

    return viewRemote;
  }

  public static class Remote extends StatelessObject implements test.Verification {
    private VerificationBean__EJB context;
    private SessionServer server;
    private ServerContainer container;

    Remote(VerificationBean__EJB context)
    {
      this.context = context;
      this.server = context.getSessionServer();
      this.container = server.getContainer();
    }

    private VerificationBean__EJB getContext()
    {
      return context;
    }

    public SessionServer getServer()
    {
      return server;
    }

    public Handle getHandle()
    {
      return getContext().getHandle();
    }

    public boolean doVerification(java.lang.String a0, java.lang.String a1, java.lang.String a2)
    {
      boolean _ret;
      TransactionContext trans = container.suspend();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false);
        _ret = ptr.doVerification(a0, a1, a2);
      } catch (RuntimeException e) {
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
        if (ptr != null) ptr._ejb_isActive = false;
      }
      return _ret;
    }
  }

  protected EJBLocalHome createLocalHome()
  {
    return new LocalHome(this);
  }

  public class LocalHome extends SessionHome implements test.VerificationLocalHome {
    private VerificationBean__EJB context;
    private SessionServer server;
    private ServerContainer container;

    LocalHome(VerificationBean__EJB context)
    {
      this.context = context;
      this.server = context.getSessionServer();
      this.container = server.getContainer();
    }

    private VerificationBean__EJB getContext()
    {
      return context;
    }

    public SessionServer getServer()
    {
      return server;
    }

    public test.VerificationLocal create()
      throws javax.ejb.CreateException
    {
      _ejb.test.VerificationBean__EJB cxt = getContext();

      return (test.VerificationLocal) cxt.getEJBLocalObject();
    }
  }

  private Local viewLocal;

  public EJBLocalObject getEJBLocalObject()
  {
    if (viewLocal == null)
      viewLocal = new Local(this);

    return viewLocal;
  }

  public static class Local extends StatelessObject implements test.VerificationLocal {
    private VerificationBean__EJB context;
    private SessionServer server;
    private ServerContainer container;

    Local(VerificationBean__EJB context)
    {
      this.context = context;
      this.server = context.getSessionServer();
      this.container = server.getContainer();
    }

    private VerificationBean__EJB getContext()
    {
      return context;
    }

    public SessionServer getServer()
    {
      return server;
    }

    public Handle getHandle()
    {
      return getContext().getHandle();
    }

    public boolean doVerification(java.lang.String a0, java.lang.String a1, java.lang.String a2)
    {
      boolean _ret;
      TransactionContext trans = container.suspend();
      Bean ptr = null;
      try {
        ptr = getContext()._caucho_begin(trans, false);
        _ret = ptr.doVerification(a0, a1, a2);
      } catch (RuntimeException e) {
        throw trans.setRollbackOnly(e);
      } finally {
        trans.commit();
        if (ptr != null) ptr._ejb_isActive = false;
      }
      return _ret;
    }
  }

  private static com.caucho.vfs.Depend []_caucho_depend;

  public static void _caucho_init(com.caucho.vfs.Path path)
  {
    _caucho_depend = new com.caucho.vfs.Depend[7];
    _caucho_depend[0] = new com.caucho.vfs.Depend(path.lookup("./AccountBean.ejb"), 1034867685354L, 3181);
    _caucho_depend[0].setRequireSource(true);
    _caucho_depend[1] = new com.caucho.vfs.Depend(path.lookup("./test/VerificationBean.class"), 1034801435242L, 397);
    _caucho_depend[1].setRequireSource(true);
    _caucho_depend[2] = new com.caucho.vfs.Depend(path.lookup("./test/VerificationHome.class"), 1034800992449L, 295);
    _caucho_depend[2].setRequireSource(true);
    _caucho_depend[3] = new com.caucho.vfs.Depend(path.lookup("./test/Verification.class"), 1034801481758L, 300);
    _caucho_depend[3].setRequireSource(true);
    _caucho_depend[4] = new com.caucho.vfs.Depend(path.lookup("./test/VerificationLocalHome.class"), 1034801163673L, 283);
    _caucho_depend[4].setRequireSource(true);
    _caucho_depend[5] = new com.caucho.vfs.Depend(path.lookup("./test/VerificationLocal.class"), 1034801482617L, 262);
    _caucho_depend[5].setRequireSource(true);
    _caucho_depend[6] = new com.caucho.vfs.Depend(path.lookup("./test/VerificationBean.class"), 1034801435242L, 397);
    _caucho_depend[6].setRequireSource(true);
  }

  public static boolean _caucho_is_modified()
  {
    if (com.caucho.ejb.Version.getVersionId() != 2003742913)
      return true;
    for (int i = _caucho_depend.length - 1; i >= 0; i--) {
      if (_caucho_depend[i].isModified())
        return true;
    }

    return false;
  }
}
